=== debian/changelog ===
seabios (0.5.1-3) unstable; urgency=low

  [ Vagrant Cascadian ]
  * Add watch file.

  [ Aurelien Jarno ]
  * Fix PS/2 mouse in old applications.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 16 Jun 2010 22:03:41 +0200

seabios (0.5.1-2) unstable; urgency=low

  * Update to 0.5.1-stable.
  * Bump Standards-Version to 3.8.4 (no changes).

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 05 Mar 2010 20:05:31 +0100

seabios (0.5.1-1) unstable; urgency=low

  [ Aurelien Jarno ]
  * Initial release (Closes: #492935).

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 26 Jan 2010 00:49:28 +0100
