=== debian/control ===
Source: seabios
Section: misc
Priority: extra
Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Aurelien Jarno <aurel32@debian.org>, Riku Voipio <riku.voipio@iki.fi>, Vagrant Cascadian <vagrant@debian.org>
Build-Depends: debhelper (>= 5), python, iasl
Standards-Version: 3.8.4

Package: seabios
Architecture: all
Depends: ${misc:Depends}
Description: Legacy BIOS implementation
 SeaBIOS is a legacy BIOS implementation, aimed at supporting not only
 emulated hosts such as QEMU, but also real hardware.
 .
 Note, however, that SeaBIOS does not handle early initialization of core
 chipsets, so don't even think of flashing it to your board (look at
 Coreboot for that).
