=== debian/changelog ===
seabios (0.6.0-0ubuntu1) maverick; urgency=low

  * Merge 0.6.0 release
    * also add all the patches from git which are included in qemu since
      May 11 (per qemu commit 14ac15d3ac8e0ef1c91204e2ac772b6412a6b99e)
    * plus the two next git patches, which are also needed for (LP: #598649)
  * switched to dpkg-source 3.0 (quilt) format
  * add a watch file

 -- Serge Hallyn <serge.hallyn@canonical.com>  Tue, 29 Jun 2010 10:42:46 -0500

seabios (0.5.1-0ubuntu2) lucid; urgency=low

  * debian/control: we only need to build this once on i386 for all arches

 -- Dustin Kirkland <kirkland@ubuntu.com>  Wed, 20 Jan 2010 11:52:10 +1300

seabios (0.5.1-0ubuntu1) lucid; urgency=low

  * Initial packaging

 -- Dustin Kirkland <kirkland@ubuntu.com>  Sun, 17 Jan 2010 14:55:10 +1300
