=== debian/watch ===
version=3

http://linuxtogo.org/~kevin/legacybios/seabios-(.*)\.tar\.gz \
	debian uupdate
