## seabios 0.6.1.2

=== debian/changelog ===
seabios (0.6.1.2-0ubuntu1) natty; urgency=low

  [ Serge Hallyn ]
  * upstream merge
    - updated debian/watch
    - remove all patches as they are applied upstream
    - removed debian-changes-0.6.0-0ubuntu2 - I'm not certain about this one,
      so it may re-introduce a regression

  [ Dustin Kirkland ]
  * debian/rules: fix lintian warnings, install changelog, make binary build
    arch indep
  * debian/control: update standards version

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Mon, 14 Feb 2011 14:38:50 -0600

seabios (0.6.0-0ubuntu2) natty; urgency=low

  * Add all patches which were included in qemu-0.13.0-rc2 (per
    commit on Jul 13, 2010).

 -- Serge Hallyn <serge.hallyn@canonical.com>  Fri, 22 Oct 2010 11:04:31 -0500
