=== debian/changelog ===
seabios (0.6.2-0ubuntu2) precise; urgency=low

  * Add all patches up to commit 8e301472e324b6d6496d8b4ffc66863e99d7a505
    to match what is shipped with qemu-kvm.  This includes the fix for a
    black screen when running kvm with -vga qxl.  (LP: #823494)
  * debian/rules: address lintian warning:
    debian-rules-missing-recommended-target

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 17 Nov 2011 12:31:22 -0600

seabios (0.6.2-0ubuntu1) oneiric; urgency=low

  * Merge 0.6.2
    - explicitly add patch 88db9fd632bf3f650244ec69e2f4fd6b2aa5fd3d to
      fix FTBFS.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 19 May 2011 10:53:14 -0500
