=== debian/control ===
Source: seabios
Section: misc
Priority: optional
Maintainer: Dustin Kirkland <kirkland@ubuntu.com>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.9.1
Homepage: http://www.coreboot.org/SeaBIOS

Package: seabios
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: legacy BIOS implementation which can be used as a coreboot payload
 SeaBIOS is an open-source legacy BIOS implementation which can be used as a
 coreboot payload. It implements the standard BIOS calling interfaces that a
 typical x86 proprietary BIOS implements.
