=== debian/watch ===
version=3

http://linuxtogo.org/~kevin/SeaBIOS/seabios-(.*)\.tar\.gz \
	debian uupdate
