=== debian/changelog ===
seabios (1.6.3-2) unstable; urgency=low

  * Add patch from 1.6.3.1 to fix usb boot paths. 

 -- Vagrant Cascadian <vagrant@debian.org>  Fri, 02 Dec 2011 19:36:13 -0800

seabios (1.6.3-1) experimental; urgency=low

  [ Michael Tokarev ]
  * New upstream release (1.6.3, jumped from 0.6.2).
    Upstream now uses kbuild-like configuration.
    Use distclean target not clean, to remove .config too.
  * Removed debian/patches/05_struct_bregs.patch (applied upstream).
  * Removed usage of $(CURDIR) from "some" debian/rules
    (it was used inconsistently and is not needed anyway).

  [ Vagrant Cascadian ]
  * debian/control: Add Vcs-* headers.
  * debian/control: Add Homepage header.
  * debian/rules: Add dummy build-arch and build-indep targets. 
  * Update optionrom patches.

 -- Vagrant Cascadian <vagrant@debian.org>  Mon, 28 Nov 2011 23:22:34 -0800

seabios (0.6.1.2-3) unstable; urgency=low

  * Add patches/05_struct_bregs.patch from upstream to fix FTBFS with
    gcc-4.6.  Closes: bug#625000.
  * Bump Standards-Version to 3.9.2 (no changes).

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 21 May 2011 11:47:36 +0200

seabios (0.6.1.2-2) unstable; urgency=low

  * Conflicts with qemu-system (<< 0.14.0).  Closes: bug#591780.
  * Switch to debhelper 7.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 19 Feb 2011 10:37:48 +0000

seabios (0.6.1.2-1) unstable; urgency=low

  * New upstream version from git tag. 
    - Fixes virtio-blk failure after reboot (Closes: #604735).
  * Update debian/watch file.

 -- Vagrant Cascadian <vagrant@debian.org>  Fri, 26 Nov 2010 17:54:44 -0800

seabios (0.6.0+git20100710-2) unstable; urgency=low

  * Temporarily reduce the conflicts on qemu-system due to the previous
    upload done in unstable instead of experimental.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 02 Aug 2010 22:52:36 +0200

seabios (0.6.0+git20100710-1) unstable; urgency=low

  * New upstream snapshot, compatible with qemu 0.13.x.
  * Add conflicts with qemu-system (<< 0.13.0).
  * Bump Standards-Version to 3.9.1 (no changes).
  * Update from QEMU 0.13:
    - 00_optionrom_buildsystem.patch
    - 02_optionrom_linuxboot.patch
  * Update from QEMU-KVM 0.13:
    - 01_optionrom_extboot.patch

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 01 Aug 2010 21:06:30 +0200
