=== debian/control ===
Source: seabios
Section: misc
Priority: extra
Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Aurelien Jarno <aurel32@debian.org>, Riku Voipio <riku.voipio@iki.fi>, Vagrant Cascadian <vagrant@debian.org>
Build-Depends: debhelper (>= 7), python, iasl
Standards-Version: 3.9.2
Vcs-Browser: http://git.debian.org/?p=pkg-qemu/seabios.git
Vcs-Git: git://git.debian.org/git/pkg-qemu/seabios.git
Homepage: http://www.seabios.org

Package: seabios
Architecture: all
Depends: ${misc:Depends}
Conflicts: qemu-system (<< 0.14.0)
Description: Legacy BIOS implementation
 SeaBIOS is a legacy BIOS implementation, aimed at supporting not only
 emulated hosts such as QEMU, but also real hardware.
 .
 Note, however, that SeaBIOS does not handle early initialization of core
 chipsets, so don't even think of flashing it to your board (look at
 Coreboot for that).
