=== debian/changelog ===
seabios (1.7.0-1~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 16 Sep 2012 16:40:57 +0400

seabios (1.7.0-1) unstable; urgency=low

  * new upstream release (1.7.0), featuring vgabios.
  * drop 1.6.3.1 patch
  * do not require root in clean target
  * split build procedure into several targets, move bios.bin
    out of out/ directory (preparing for the next change), and
    change clean target accordingly
  * build and ship vgabios-{cirrus,stdvga,vmware,qxl,isavga}.bin
  * patches/fix-==-in-shell.patch -- fix build error with dash
  * move all optionrom files taken from qemu into debian/optionrom,
    instead of having them as patches in debian/patches.  While at
    it, update optionroms from current qemu (1.1) and add
    vapic.bin => kvmvapic.bin compatibility symlink.
  * add myself to uploaders
  * bump Standards-Version to 3.9.3 (no changes needed)

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 17 Apr 2012 14:22:01 +0400
