=== debian/control ===
--- 
+++ 
@@ -2,9 +2,10 @@
 Section: misc
 Priority: extra
 Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
-Uploaders: Aurelien Jarno <aurel32@debian.org>, Riku Voipio <riku.voipio@iki.fi>, Vagrant Cascadian <vagrant@debian.org>
+Uploaders: Aurelien Jarno <aurel32@debian.org>, Riku Voipio <riku.voipio@iki.fi>, Vagrant Cascadian <vagrant@debian.org>,
+	Michael Tokarev <mjt@tls.msk.ru>
 Build-Depends: debhelper (>= 7), python, iasl
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Vcs-Browser: http://git.debian.org/?p=pkg-qemu/seabios.git
 Vcs-Git: git://git.debian.org/git/pkg-qemu/seabios.git
 Homepage: http://www.seabios.org
