=== debian/rules ===
--- 
+++ 
@@ -10,26 +10,59 @@
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
 
-build: build-arch build-indep
-build-arch: build-stamp
-build-indep: build-stamp
-build-stamp:
+VGABIOSES = cirrus stdvga vmware qxl isavga
+VGABIOS_TARGETS = $(addprefix vgabios-, $(addsuffix .bin, $(VGABIOSES)))
+BUILD_TARGETS = bios.bin $(VGABIOS_TARGETS) build-optionrom-stamp
+
+build build-arch build-indep: $(BUILD_TARGETS)
+
+bios.bin:
 	dh_testdir
 	$(MAKE) src/acpi-dsdt.hex
-	$(MAKE)
-	$(MAKE) -C optionrom
-	chmod -x optionrom/*bin
+	$(MAKE) out/bios.bin
+	mv out/bios.bin bios.bin
+
+build-optionrom-stamp:
+	$(MAKE) -C debian/optionrom/
+	chmod -x debian/optionrom/*.bin
+	ln -s kvmvapic.bin debian/optionrom/vapic.bin
 	touch $@
+
+define build-vgabios
+rm -rf out/
+rm -f .config
+for x in BUILD_VGABIOS=y $1; do echo CONFIG_$$x; done > .config
+$(MAKE) oldnoconfig
+$(MAKE) out/vgabios.bin
+mv out/vgabios.bin $@
+endef
+
+# Since we use the same .config (and make oldconfig),
+# we can't make all vgabios-*.bin in parallel with each other.
+# Ensure they're made one after another by specifying
+# that next depends on previous, ie, making a dependency chain,
+# starting with main bios.bin
+
+vgabios-cirrus.bin: bios.bin
+	$(call build-vgabios,VGA_CIRRUS=y VGA_PCI=y)
+vgabios-stdvga.bin: vgabios-cirrus.bin
+	$(call build-vgabios,VGA_BOCHS=y VGA_PCI=y)
+vgabios-vmware.bin: vgabios-stdvga.bin
+	$(call build-vgabios,VGA_BOCHS=y VGA_PCI=y OVERRIDE_PCI_ID=y VGA_VID=0x15ad VGA_DID=0x0405)
+vgabios-qxl.bin: vgabios-vmware.bin
+	$(call build-vgabios,VGA_BOCHS=y VGA_PCI=y OVERRIDE_PCI_ID=y VGA_VID=0x1b36 VGA_DID=0x0100)
+vgabios-isavga.bin: vgabios-qxl.bin
+	$(call build-vgabios,VGA_BOCHS=y VGA_PCI=n)
 
 clean:
 	dh_testdir
-	dh_testroot
-	rm -f build-stamp
-	$(MAKE) distclean
-	! [ -f optionrom/Makefile ] || $(MAKE) -C optionrom clean
+	rm -f $(BUILD_TARGETS)
+	rm -f .config .config.old
+	rm -rf out/
 	rm -f src/acpi-dsdt.aml
 	rm -f src/acpi-dsdt.hex
 	rm -f tools/*pyc
+	$(MAKE) -C debian/optionrom/ clean
 	dh_clean
 
 install: build
